'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.FormProvider = exports.FormEventDispatcher = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _provider = require('./provider.actions');

var _provider2 = require('./provider.utils');

var _provider3 = require('./provider.reducer');

var _provider4 = require('./provider.effects');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var PROVIDER_EVENT = _provider.REACT_FORMCTRL_NAME + '.FormProvider';

var FormEventDispatcher = exports.FormEventDispatcher = function () {
    function FormEventDispatcher() {
        _classCallCheck(this, FormEventDispatcher);
    }

    _createClass(FormEventDispatcher, null, [{
        key: 'dispatchRegisterForm',
        value: function dispatchRegisterForm(form) {
            var payload = { detail: (0, _provider.onRegisterForm)(form) };
            var event = new CustomEvent(PROVIDER_EVENT, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchUnregisterForm',
        value: function dispatchUnregisterForm(form) {
            var payload = { detail: (0, _provider.onUnregisterForm)(form) };
            var event = new CustomEvent(PROVIDER_EVENT, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchSubmitForm',
        value: function dispatchSubmitForm(form, formRef) {
            var payload = { detail: (0, _provider.onSubmitForm)(form, formRef) };
            var event = new CustomEvent(PROVIDER_EVENT, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchResetForm',
        value: function dispatchResetForm(form) {
            var payload = { detail: (0, _provider.onResetForm)(form) };
            var event = new CustomEvent(PROVIDER_EVENT, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchRegisterField',
        value: function dispatchRegisterField(form, field, fieldCtrl) {
            var payload = { detail: (0, _provider.onRegisterField)(form, field, fieldCtrl) };
            var event = new CustomEvent(PROVIDER_EVENT, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchUnregisterField',
        value: function dispatchUnregisterField(form, field) {
            var payload = { detail: (0, _provider.onUnregisterField)(form, field) };
            var event = new CustomEvent(PROVIDER_EVENT, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchFieldPropsChanged',
        value: function dispatchFieldPropsChanged(form, field, props) {
            var payload = { detail: (0, _provider.onFieldPropsChanged)(form, field, props) };
            var event = new CustomEvent(PROVIDER_EVENT, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchFieldChanged',
        value: function dispatchFieldChanged(form, field, value, files) {
            var payload = { detail: (0, _provider.onFieldChanged)(form, field, value, files) };
            var event = new CustomEvent(PROVIDER_EVENT, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchFieldBlur',
        value: function dispatchFieldBlur(form, field) {
            var payload = { detail: (0, _provider.onFieldBlur)(form, field) };
            var event = new CustomEvent(PROVIDER_EVENT, payload);
            document.dispatchEvent(event);
        }
    }, {
        key: 'dispatchRegisterValidators',
        value: function dispatchRegisterValidators(validators) {
            var payload = { detail: (0, _provider.onRegisterValidators)(validators) };
            var event = new CustomEvent(PROVIDER_EVENT, payload);
            document.dispatchEvent(event);
        }
    }]);

    return FormEventDispatcher;
}();

var FormProvider = exports.FormProvider = function (_React$Component) {
    _inherits(FormProvider, _React$Component);

    function FormProvider(props) {
        _classCallCheck(this, FormProvider);

        var _this = _possibleConstructorReturn(this, (FormProvider.__proto__ || Object.getPrototypeOf(FormProvider)).call(this, props));

        _this.state = {
            forms: {},
            validators: {}
        };
        _this.onEvent = _this.onEvent.bind(_this);
        return _this;
    }

    _createClass(FormProvider, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            document.addEventListener(PROVIDER_EVENT, this.onEvent);
            var _props$validators = this.props.validators,
                validators = _props$validators === undefined ? [] : _props$validators;

            FormEventDispatcher.dispatchRegisterValidators(validators);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            document.removeEventListener(PROVIDER_EVENT, this.onEvent);
        }
    }, {
        key: 'onEvent',
        value: function onEvent(event) {
            var action = event.detail;
            this.setState(function (state) {
                var newState = (0, _provider3.formProviderReducer)(state, action);
                (0, _provider4.formProviderEffects)(newState, action);
                return newState;
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var children = this.props.children;

            return children;
        }
    }]);

    return FormProvider;
}(_react2.default.Component);

FormProvider.propTypes = {
    customValidators: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        name: _propTypes2.default.string.isRequired,
        validate: _propTypes2.default.func.isRequired
    }))
};